VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Application"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Make sure that a reference to the swpublished.tlb type library exists

'Tell VB that you are going to provide functionality for the SwAddin interface
Implements SWPublished.SwAddin

Dim iSldWorks                   As SldWorks.SldWorks
Dim iCookie                     As Long
Dim iToolbarID                  As Long

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Implementation methods of the SwAddin interface
Private Function SwAddin_ConnectToSW(ByVal ThisSW As Object, ByVal Cookie As Long) As Boolean
    Dim bRet                As Boolean
    
    ' store reference to SW session
    Set iSldWorks = ThisSW
    
    ' store cookie from SW
    iCookie = Cookie
    
    'Inform SW about the object that contains the callbacks
    bRet = iSldWorks.SetAddinCallbackInfo(App.hInstance, Me, iCookie)
    
    'Add a toolbar
    iToolbarID = iSldWorks.AddToolbar3(iCookie, "Visibility Toolbar", 102, 101, -1, _
                    swDocTemplateTypeNONE + swDocTemplateTypePART + swDocTemplateTypeASSEMBLY + swDocTemplateTypeDRAWING)
    'Add buttons
    bRet = iSldWorks.AddToolbarCommand2(iCookie, iToolbarID, 0, "ToolbarPlane", _
                "ToolbarPlaneUpdate", "Ebenen", "Elemente Ein-/Ausblenden")
                
    bRet = iSldWorks.AddToolbarCommand2(iCookie, iToolbarID, 1, "ToolbarAxe", _
                "ToolbarAxeUpdate", "Achsen", "Elemente Ein-/Ausblenden")
                
    bRet = iSldWorks.AddToolbarCommand2(iCookie, iToolbarID, 2, "ToolbarOrigin", _
                "ToolbarOriginUpdate", "Ursprnge", "Elemente Ein-/Ausblenden")
                
    bRet = iSldWorks.AddToolbarCommand2(iCookie, iToolbarID, 3, "ToolbarSketch", _
                "ToolbarSketchUpdate", "Skizzen", "Elemente Ein-/Ausblenden")
                
    bRet = iSldWorks.AddToolbarCommand2(iCookie, iToolbarID, 4, "", "", "", "")
    
    bRet = iSldWorks.AddToolbarCommand2(iCookie, iToolbarID, 5, "ToolbarAll", _
                "ToolbarAllUpdate", "Alles", "Elemente Ausblenden")
                
    ' DO NOT use - toolbar visibility managed by SW
    'bRet = iSldWorks.ShowToolbar2(iCookie, iToolbarID)
    
    SwAddin_ConnectToSW = True
End Function

Private Function SwAddin_DisconnectFromSW() As Boolean
    Dim bRet            As Boolean
    
    'Remove any UI that was added earlier
    bRet = iSldWorks.RemoveToolbar2(iCookie, iToolbarID)
    
    Set iSldWorks = Nothing
    
    SwAddin_DisconnectFromSW = True
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Callback routines for SW
Public Sub ToolbarPlane()
    Dim val, res As Boolean
    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        Exit Sub
    End If
    ' Get current setting
    val = iSldWorks.ActiveDoc.GetUserPreferenceToggle(5)
    If val = True Then
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(5, False)
    Else
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(5, True)
    End If
End Sub

Public Function ToolbarPlaneUpdate() As Long
    Dim val As Boolean
    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        ToolbarPlaneUpdate = 0
        Exit Function
    End If
    
    If iSldWorks.ActiveDoc.GetUserPreferenceToggle(5) = True Then
        ToolbarPlaneUpdate = 3
    Else
        ToolbarPlaneUpdate = 1
    End If
End Function

Sub ToolbarAxe()
    Dim val, res As Boolean
    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        Exit Sub
    End If

    ' Get current setting
    val = iSldWorks.ActiveDoc.GetUserPreferenceToggle(4) Or iSldWorks.ActiveDoc.GetUserPreferenceToggle(7)

    If val = True Then
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(4, False)
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(7, False)
    Else
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(4, True)
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(7, True)
    End If

End Sub

Public Function ToolbarAxeUpdate() As Long

    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        ToolbarAxeUpdate = 0
        Exit Function
    End If

    If iSldWorks.ActiveDoc.GetUserPreferenceToggle(4) = True Or iSldWorks.ActiveDoc.GetUserPreferenceToggle(7) Then
        ToolbarAxeUpdate = 3
    Else
        ToolbarAxeUpdate = 1
    End If
End Function

Sub ToolbarOrigin()
    Dim val, res As Boolean
    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        Exit Sub
    End If

    ' Get current setting
    val = iSldWorks.ActiveDoc.GetUserPreferenceToggle(6)

    If val = True Then
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(6, False)
    Else
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(6, True)
    End If

End Sub

Public Function ToolbarOriginUpdate() As Long

    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        ToolbarOriginUpdate = 0
        Exit Function
    End If

    If iSldWorks.ActiveDoc.GetUserPreferenceToggle(6) = True Then
        ToolbarOriginUpdate = 3
    Else
        ToolbarOriginUpdate = 1
    End If
End Function

Sub ToolbarSketch()
    Dim val, res As Boolean
    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        Exit Sub
    End If

    ' Get current setting
    val = iSldWorks.ActiveDoc.GetUserPreferenceToggle(196)

    If val = True Then
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(196, False)
    Else
        res = iSldWorks.ActiveDoc.SetUserPreferenceToggle(196, True)
    End If

End Sub

Public Function ToolbarSketchUpdate() As Long

    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        ToolbarSketchUpdate = 0
        Exit Function
    End If

    If iSldWorks.ActiveDoc.GetUserPreferenceToggle(196) = True Then
        ToolbarSketchUpdate = 3
    Else
        ToolbarSketchUpdate = 1
    End If
End Function


Sub ToolbarAll()
    Dim boolstatus As Boolean

    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        Exit Sub
    End If
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(198, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(5, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(4, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(7, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(6, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(13, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(195, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(196, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(197, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(219, False)
    boolstatus = iSldWorks.ActiveDoc.SetUserPreferenceToggle(19, False)
End Sub

Public Function ToolbarAllUpdate() As Long

    ' Exit if no model is active
    If iSldWorks.ActiveDoc Is Nothing Then
        ToolbarAllUpdate = 0
        Exit Function
    End If

    If iSldWorks.ActiveDoc.GetUserPreferenceToggle(198) = True Then
        ToolbarAllUpdate = 3
    Else
        ToolbarAllUpdate = 1
    End If
End Function
